diff -Naur openssl-1.0.0q.orig/selftest/TestCA/crls/crl2.pem openssl-1.0.0q/selftest/TestCA/crls/crl2.pem
--- openssl-1.0.0q.orig/selftest/TestCA/crls/crl2.pem	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/selftest/TestCA/crls/crl2.pem	2017-04-25 16:23:41.379031410 +0200
@@ -0,0 +1,40 @@
+Certificate Revocation List (CRL):
+        Version 2 (0x1)
+        Signature Algorithm: sha1WithRSAEncryption
+        Issuer: /CN=Libopeay test CA/O=Opera/ST=Oslo/C=NO
+        Last Update: Mar 22 09:06:53 2012 GMT
+        Next Update: Mar 20 09:06:53 2022 GMT
+        CRL extensions:
+            X509v3 CRL Number: 
+                2
+Revoked Certificates:
+    Serial Number: 02
+        Revocation Date: Mar 22 09:06:53 2012 GMT
+    Signature Algorithm: sha1WithRSAEncryption
+        50:92:f8:bf:87:4f:94:2f:56:a8:e5:36:ee:04:e3:e5:bd:e3:
+        25:27:bd:95:ea:85:25:fd:ec:22:2f:f8:ed:aa:c4:45:2a:1c:
+        e1:c1:97:7a:32:84:93:83:14:f3:6d:da:25:5a:f2:47:fa:17:
+        47:44:20:3d:78:a0:f0:9c:29:28:5c:db:06:51:ad:9b:f3:9f:
+        fb:e1:e9:6b:4d:db:7b:29:97:6b:41:5e:52:94:27:9a:52:57:
+        a5:06:e6:ae:fe:7c:69:0c:4a:86:53:04:29:9c:24:c9:3b:22:
+        27:3f:42:da:aa:f1:5e:29:5a:54:a5:54:34:b9:c8:9d:c1:fc:
+        e9:08:37:e3:9a:ae:66:ce:33:0f:8d:64:3c:f0:8a:f3:44:7e:
+        f0:5d:5a:05:ff:9c:36:0a:fd:12:4f:e0:78:38:58:73:2c:fa:
+        07:d1:42:ae:7a:36:00:e4:03:49:cb:ba:07:29:85:37:f3:70:
+        2e:21:f6:8e:8a:a6:ce:6a:18:0c:ee:71:c2:f3:fb:fb:86:6a:
+        65:2e:ad:e3:04:25:c0:b0:c7:87:7e:c0:a3:1d:c4:4e:cd:c7:
+        24:1c:79:32:4c:57:21:30:c7:1c:78:66:98:ea:1e:b8:d3:0a:
+        bc:1b:1f:0a:e8:a3:74:b7:69:d1:32:f7:16:14:73:5b:34:29:
+        f2:bc:a2:ba
+-----BEGIN X509 CRL-----
+MIIBtjCBnwIBATANBgkqhkiG9w0BAQUFADBHMRkwFwYDVQQDDBBMaWJvcGVheSB0
+ZXN0IENBMQ4wDAYDVQQKDAVPcGVyYTENMAsGA1UECAwET3NsbzELMAkGA1UEBhMC
+Tk8XDTEyMDMyMjA5MDY1M1oXDTIyMDMyMDA5MDY1M1owFDASAgECFw0xMjAzMjIw
+OTA2NTNaoA4wDDAKBgNVHRQEAwIBAjANBgkqhkiG9w0BAQUFAAOCAQEAUJL4v4dP
+lC9WqOU27gTj5b3jJSe9leqFJf3sIi/47arERSoc4cGXejKEk4MU823aJVryR/oX
+R0QgPXig8JwpKFzbBlGtm/Of++Hpa03beymXa0FeUpQnmlJXpQbmrv58aQxKhlME
+KZwkyTsiJz9C2qrxXilaVKVUNLnIncH86Qg345quZs4zD41kPPCK80R+8F1aBf+c
+Ngr9Ek/geDhYcyz6B9FCrno2AOQDScu6BymFN/NwLiH2joqmzmoYDO5xwvP7+4Zq
+ZS6t4wQlwLDHh37Aox3ETs3HJBx5MkxXITDHHHhmmOoeuNMKvBsfCuijdLdp0TL3
+FhRzWzQp8ryiug==
+-----END X509 CRL-----
diff -Naur openssl-1.0.0q.orig/selftest/TestCA/keys/key1.pem openssl-1.0.0q/selftest/TestCA/keys/key1.pem
--- openssl-1.0.0q.orig/selftest/TestCA/keys/key1.pem	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/selftest/TestCA/keys/key1.pem	2017-04-25 16:23:41.380031258 +0200
@@ -0,0 +1,27 @@
+-----BEGIN RSA PRIVATE KEY-----
+MIIEpAIBAAKCAQEAvwHqT0VBHpaDXUJKoitwFvjbeexmB0VKioXQK8HwbofZ4a0f
+6pyLDVw/b5zLjLOIGsEQDV9TDZL8cjArRj4Fj9F62V721Kg6IMrILOy0jcWRDrO0
+ma0OXEN1wgCNuOkRVHFg5HEZVm3Lc8qkPTzv3ggOkBsvpIqBgf3KUBegplyog2w2
+VKkP8/G6sf2qkgcuZk5RSrv+XM+SDe8o4JUS/q9f/Jo9JENSD0EVmZ6E/P13byuX
+VH7NuuchD1IuiVuDnQ02K8JiMq7eAvL/ntU1rbh3jQbPHu7NwFR6PartgtFk332H
+34/Pncz911i2r4cDGQvFIfHIg3K8o/2DuKul1wIDAQABAoIBAQCz0lbICFgVNvg3
+XUisQh7F0cW2lEM9xxM1NGNWPsBfHtCWMQniMzyJ+HXUWxYawY56OZYmML8dAWtf
+CVBEUfGkgz+X01qnvDT1WFN6T+JvsjctUyvMneruG6iKW0ERe4KQMClbB8sl3jnz
+KizTZkIgkw86xg1lZ+wi+E52drgMxX8FI45hfk7ODZyjkuY+Mvhb7G9710jOznJT
+seqtynipHoCUAPWjcLuGJI9XU1kQo1SO3DGxwzUr3K+OD2o6p3R03EBEZb9//5DH
+GzzFfnEVNPis1LHs19+8i/4mdIo2VpezMLqRCqsFki1JGIm26zvl1VpiQUz/nWD9
+KIctaorhAoGBAPEueAsQbD/BUpj8F2O1v8EWPTQ38BR8jeQrE5A7FdDNcEMuRaB+
+ReNUu94e2xBHOja+tA8euHe9RnP6FQoS16nWr2h2DN+j1KBLLuJscmGs24PNg6k6
+VzLq6pGNmSdOmyTnSy1okwqTRXCwd45FH9Tu0Z1qExERfTgdrDw1ZyvxAoGBAMq+
+Qvnuwe0HY73dL5KfvuzTX12GjAv5OrmEBfIDPBK/jNYNWJFLaoO3NHBFEO+c4OKi
+kGZhyzQCObu7CS9svrsugw74MPLKRcfFRHYE86HJkAoTXIhb4+BwP+docHjlori8
+gC9DuBzuoB6GgZ2XMqCscrDgAZsfi+ssTZoOg9ZHAoGARaF95Ovb5NhCqYp2kkIB
+15Q9HVtdA/0l1g8dudFlLgBx/eNZFMoAEW8AQlO0OVHnG7EZORhMd718nrU/58Wi
+4BTsVYNnmhWpqJGsOpDGwS5vvfDSp0QBsuCh0l4ILpICNrhUOwrrEO2N6cf47GlG
+lGpSuFjMomvjNBVVCZj9bXECgYBWAE845eatPS06JNFBSTIcE62oZqKRka8vcqly
+95xL96UuR4sCVxNfvB8qYKHGgq2CdaL7SxB/h1ImKDjFPUPK8vf1KaLZ2qOvEibw
+STlvr6jCHWRrE0+erP7ukobjQcW8x3k4k2lOHIsfZ78jsjdvoLcmAF+uBbu8jpZ8
+exvBkQKBgQCw4+8fypZAtoFe6KymwJ5JCbwnAuU58y9Nlz+KHUd4utXh4N5HNtyV
+FuQfhY/1QcENIR2NiijFsgrA3cb6DBls0V1yRUS5LlYALFrQ0yIEv8Zb5s61tYrE
+LiV+H65Tl5zqOKV0bQwufqYipjzSkoS7PH5mkJMKYX3fiS8GUYrvVQ==
+-----END RSA PRIVATE KEY-----
diff -Naur openssl-1.0.0q.orig/selftest/TestCA/keys/key2.pem openssl-1.0.0q/selftest/TestCA/keys/key2.pem
--- openssl-1.0.0q.orig/selftest/TestCA/keys/key2.pem	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/selftest/TestCA/keys/key2.pem	2017-04-25 16:23:41.380031258 +0200
@@ -0,0 +1,27 @@
+-----BEGIN RSA PRIVATE KEY-----
+MIIEowIBAAKCAQEAxv0r2FzWouV6DpG6cRigefnSrSXqlRZi3Jf0Ey+ACnGbaW6G
+PBFNau1bDXSn4CI24Pccqozm0t2FhH+YF78MCmxpgPlyYfpWYHw8QpgpGod9nhEy
+HfhgV8lzTCppu54P9qSwyUC/TfPhz/ktee1KZHWo94Kpe4b6LOtJ+B2nHOtpbM3t
+4B5pfBv83EIvaEabq2ZFgzXyw43Wz7BmpYECBcXbx8czsoCvnY610XGXRvgsVSPi
+M4CgDjfGpSYeKESnU1rHkWcwQNiamHXBHUvF7RaaQMKhAzOZBdTCPEGPeXWueavr
+0u+OD++Ta6UYwxO65MPphMwxXK4IHrzeSiA9SQIDAQABAoIBAQCNC2SpntyQaCHE
+8+x4P6F38+kty8Nj25NFkvtxIeka/f3PlITXTNhYI1e3yOk5SGcnvGB4TxlJe7Uo
+/pvasRMizEdYIPe/lQbmqwi3l00DPeh/QucIMUZw0xzDbwi08MuV4pRggmFXKrfz
+h0aBtv1VCcUzc00YfssTTc+Ha9VI/B67tHauNFh8iq+o8ztv0B9hsc03rMXEkIDo
+GM6yuNKrMD5IwDJ+DonQ/epEpBORwS0b55CFgcgEhfBWXW1Q9LEoYptpVjPYoVwj
+zaaztsMB4bKHNArtKk6yUVYNPC0bTZSKMhTQNPa0Eb2qtjg5K3WmLdsM325mLVJd
+K4HALZ9VAoGBAPg7Frjrzk2UNd4pMinRK6HnXHRzMJgIr3jYf7oExg6YM0ZnyrYK
+TPgMTw7pXN9cDelNT1ngPXiedYrGm4RCADrnV4+FJdtCI7EPCizgfLYBEm3Uqw8U
+ztJYJ3URjXbAqe13GM8J7by/iA4tJscIS6ZevEVOEOTdhLLNo3FMk5WDAoGBAM03
+iiWw29oOYYJHXN1FnKcUnk9BT5Wc0OERVINdTnXSjNam8raM930Wei1CqC3ejjDy
+37Y992L8dX07o537IbWeLhWOH27kTXew1e6ZOCbnkKltdg30NNe2/uwJ6ul9iz/K
+Ze2auM24g8VjmAAo8ndCeVCCcDjAzzRK4M/uILRDAoGAaGI4qOSIKXlkuZprPMh3
+56pp55I04gns+A1akLfHLYX1MesdhDWKrlhGuoeJhWepde0LrEiusNU5qnTgGtrC
+TALSgEjGZZBHgAJKDhsMdmC3BjaDBGGEo1Fsrj8GVOSp0HDfntiW/2MvbH6yKsoj
+Pb/iveYZFpTMY4Az9cX03c8CgYBywnFNvIZlfY9H1HJ5BtmgkaYp+gLwTp58jj1t
+rLsYpmK+EuQ987zexbgTIWh9Jizr8JXsCuESCM4G91f7G5nxP4DT6wNm9uLfYRNx
+d1twXiSGqsDO8tauHxaVlsI4Sk2Zoay4X8KiwGFn+9bfmAZnbNP8ksUA58m3m3v2
+q1q8kwKBgC2SlV6do7bkU71avD33LhSncb/qng9T2usaWeIcjwEbqXxBOl92YvNj
+qQlHWqf1rYi+lGWtoUqyBTXFoHbtvrHz1EZxAItCUAwQeXBHnbiHQnhzQ+nIha1p
+AAqSONUOjRvuUlH081hMaRdcCU7c12uuiVLrsIdgh4IfByzGwBdt
+-----END RSA PRIVATE KEY-----
diff -Naur openssl-1.0.0q.orig/selftest/TestCA/openssl.cnf openssl-1.0.0q/selftest/TestCA/openssl.cnf
--- openssl-1.0.0q.orig/selftest/TestCA/openssl.cnf	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/selftest/TestCA/openssl.cnf	2017-04-25 16:23:41.381030826 +0200
@@ -0,0 +1,350 @@
+#
+# OpenSSL example configuration file.
+# This is mostly being used for generation of certificate requests.
+#
+
+# This definition stops the following lines choking if HOME isn't
+# defined.
+HOME			= .
+RANDFILE		= $ENV::HOME/.rnd
+
+# Extra OBJECT IDENTIFIER info:
+#oid_file		= $ENV::HOME/.oid
+oid_section		= new_oids
+
+# To use this configuration file with the "-extfile" option of the
+# "openssl x509" utility, name here the section containing the
+# X.509v3 extensions to use:
+# extensions		= 
+# (Alternatively, use a configuration file that has only
+# X.509v3 extensions in its main [= default] section.)
+
+[ new_oids ]
+
+# We can add new OIDs in here for use by 'ca', 'req' and 'ts'.
+# Add a simple OID like this:
+# testoid1=1.2.3.4
+# Or use config file substitution like this:
+# testoid2=${testoid1}.5.6
+
+# Policies used by the TSA examples.
+tsa_policy1 = 1.2.3.4.1
+tsa_policy2 = 1.2.3.4.5.6
+tsa_policy3 = 1.2.3.4.5.7
+
+####################################################################
+[ ca ]
+default_ca	= CA_default		# The default ca section
+
+####################################################################
+[ CA_default ]
+
+dir		= .		# Where everything is kept
+certs		= $dir/certs		# Where the issued certs are kept
+crl_dir		= $dir/crls		# Where the issued crl are kept
+database	= $dir/ca-data/index.txt	# database index file.
+#unique_subject	= no			# Set to 'no' to allow creation of
+					# several ctificates with same subject.
+new_certs_dir	= $dir/ca-data/certs		# default place for new certs.
+
+certificate	= $dir/ca-data/cacert.pem 	# The CA certificate
+serial		= $dir/ca-data/serial 		# The current serial number
+crlnumber	= $dir/ca-data/crlnumber	# the current crl number
+					# must be commented out to leave a V1 CRL
+crl		= $dir/ca-data/crl.pem 		# The current CRL
+private_key	= $dir/ca-data/cakey.pem # The private key
+RANDFILE	= $dir/ca-data/.rand	# private random number file
+
+x509_extensions	= usr_cert		# The extentions to add to the cert
+
+# Comment out the following two lines for the "traditional"
+# (and highly broken) format.
+name_opt 	= ca_default		# Subject Name options
+cert_opt 	= ca_default		# Certificate field options
+
+# Extension copying option: use with caution.
+# copy_extensions = copy
+
+# Extensions to add to a CRL. Note: Netscape communicator chokes on V2 CRLs
+# so this is commented out by default to leave a V1 CRL.
+# crlnumber must also be commented out to leave a V1 CRL.
+# crl_extensions	= crl_ext
+
+default_days	= 365		# how long to certify for
+default_crl_days= 30			# how long before next CRL
+default_md	= default		# use public key default MD
+preserve	= no			# keep passed DN ordering
+
+# A few difference way of specifying how similar the request should look
+# For type CA, the listed attributes must be the same, and the optional
+# and supplied fields are just that :-)
+policy		= policy_match
+
+# For the CA policy
+[ policy_match ]
+countryName		= match
+stateOrProvinceName	= match
+organizationName	= match
+organizationalUnitName	= optional
+commonName		= supplied
+emailAddress		= optional
+
+# For the 'anything' policy
+# At this point in time, you must list all acceptable 'object'
+# types.
+[ policy_anything ]
+countryName		= optional
+stateOrProvinceName	= optional
+localityName		= optional
+organizationName	= optional
+organizationalUnitName	= optional
+commonName		= supplied
+emailAddress		= optional
+
+####################################################################
+[ req ]
+default_bits		= 1024
+default_keyfile 	= privkey.pem
+distinguished_name	= req_distinguished_name
+attributes		= req_attributes
+x509_extensions	= v3_ca	# The extentions to add to the self signed cert
+
+# Passwords for private keys if not present they will be prompted for
+# input_password = secret
+# output_password = secret
+
+# This sets a mask for permitted string types. There are several options. 
+# default: PrintableString, T61String, BMPString.
+# pkix	 : PrintableString, BMPString (PKIX recommendation before 2004)
+# utf8only: only UTF8Strings (PKIX recommendation after 2004).
+# nombstr : PrintableString, T61String (no BMPStrings or UTF8Strings).
+# MASK:XXXX a literal mask value.
+# WARNING: ancient versions of Netscape crash on BMPStrings or UTF8Strings.
+string_mask = utf8only
+
+# req_extensions = v3_req # The extensions to add to a certificate request
+
+[ req_distinguished_name ]
+countryName			= Country Name (2 letter code)
+countryName_default		= AU
+countryName_min			= 2
+countryName_max			= 2
+
+stateOrProvinceName		= State or Province Name (full name)
+stateOrProvinceName_default	= Some-State
+
+localityName			= Locality Name (eg, city)
+
+0.organizationName		= Organization Name (eg, company)
+0.organizationName_default	= Internet Widgits Pty Ltd
+
+# we can do this but it is not needed normally :-)
+#1.organizationName		= Second Organization Name (eg, company)
+#1.organizationName_default	= World Wide Web Pty Ltd
+
+organizationalUnitName		= Organizational Unit Name (eg, section)
+#organizationalUnitName_default	=
+
+commonName			= Common Name (e.g. server FQDN or YOUR name)
+commonName_max			= 64
+
+emailAddress			= Email Address
+emailAddress_max		= 64
+
+# SET-ex3			= SET extension number 3
+
+[ req_attributes ]
+challengePassword		= A challenge password
+challengePassword_min		= 4
+challengePassword_max		= 20
+
+unstructuredName		= An optional company name
+
+[ usr_cert ]
+
+# These extensions are added when 'ca' signs a request.
+
+# This goes against PKIX guidelines but some CAs do it and some software
+# requires this to avoid interpreting an end user certificate as a CA.
+
+basicConstraints=CA:FALSE
+
+# Here are some examples of the usage of nsCertType. If it is omitted
+# the certificate can be used for anything *except* object signing.
+
+# This is OK for an SSL server.
+# nsCertType			= server
+
+# For an object signing certificate this would be used.
+# nsCertType = objsign
+
+# For normal client use this is typical
+# nsCertType = client, email
+
+# and for everything including object signing:
+# nsCertType = client, email, objsign
+
+# This is typical in keyUsage for a client certificate.
+# keyUsage = nonRepudiation, digitalSignature, keyEncipherment
+
+# This will be displayed in Netscape's comment listbox.
+nsComment			= "OpenSSL Generated Certificate"
+
+# PKIX recommendations harmless if included in all certificates.
+subjectKeyIdentifier=hash
+authorityKeyIdentifier=keyid,issuer
+
+# This stuff is for subjectAltName and issuerAltname.
+# Import the email address.
+# subjectAltName=email:copy
+# An alternative to produce certificates that aren't
+# deprecated according to PKIX.
+# subjectAltName=email:move
+
+# Copy subject details
+# issuerAltName=issuer:copy
+
+#nsCaRevocationUrl		= http://www.domain.dom/ca-crl.pem
+#nsBaseUrl
+#nsRevocationUrl
+#nsRenewalUrl
+#nsCaPolicyUrl
+#nsSslServerName
+
+# This is required for TSA certificates.
+# extendedKeyUsage = critical,timeStamping
+
+[ v3_req ]
+
+# Extensions to add to a certificate request
+
+basicConstraints = CA:FALSE
+keyUsage = nonRepudiation, digitalSignature, keyEncipherment
+
+[ v3_ca ]
+
+
+# Extensions for a typical CA
+
+
+# PKIX recommendation.
+
+subjectKeyIdentifier=hash
+
+authorityKeyIdentifier=keyid:always,issuer
+
+# This is what PKIX recommends but some broken software chokes on critical
+# extensions.
+#basicConstraints = critical,CA:true
+# So we do this instead.
+basicConstraints = CA:true
+
+# Key usage: this is typical for a CA certificate. However since it will
+# prevent it being used as an test self-signed certificate it is best
+# left out by default.
+# keyUsage = cRLSign, keyCertSign
+
+# Some might want this also
+# nsCertType = sslCA, emailCA
+
+# Include email address in subject alt name: another PKIX recommendation
+# subjectAltName=email:copy
+# Copy issuer details
+# issuerAltName=issuer:copy
+
+# DER hex encoding of an extension: beware experts only!
+# obj=DER:02:03
+# Where 'obj' is a standard or added object
+# You can even override a supported extension:
+# basicConstraints= critical, DER:30:03:01:01:FF
+
+[ crl_ext ]
+
+# CRL extensions.
+# Only issuerAltName and authorityKeyIdentifier make any sense in a CRL.
+
+# issuerAltName=issuer:copy
+authorityKeyIdentifier=keyid:always
+
+[ proxy_cert_ext ]
+# These extensions should be added when creating a proxy certificate
+
+# This goes against PKIX guidelines but some CAs do it and some software
+# requires this to avoid interpreting an end user certificate as a CA.
+
+basicConstraints=CA:FALSE
+
+# Here are some examples of the usage of nsCertType. If it is omitted
+# the certificate can be used for anything *except* object signing.
+
+# This is OK for an SSL server.
+# nsCertType			= server
+
+# For an object signing certificate this would be used.
+# nsCertType = objsign
+
+# For normal client use this is typical
+# nsCertType = client, email
+
+# and for everything including object signing:
+# nsCertType = client, email, objsign
+
+# This is typical in keyUsage for a client certificate.
+# keyUsage = nonRepudiation, digitalSignature, keyEncipherment
+
+# This will be displayed in Netscape's comment listbox.
+nsComment			= "OpenSSL Generated Certificate"
+
+# PKIX recommendations harmless if included in all certificates.
+subjectKeyIdentifier=hash
+authorityKeyIdentifier=keyid,issuer
+
+# This stuff is for subjectAltName and issuerAltname.
+# Import the email address.
+# subjectAltName=email:copy
+# An alternative to produce certificates that aren't
+# deprecated according to PKIX.
+# subjectAltName=email:move
+
+# Copy subject details
+# issuerAltName=issuer:copy
+
+#nsCaRevocationUrl		= http://www.domain.dom/ca-crl.pem
+#nsBaseUrl
+#nsRevocationUrl
+#nsRenewalUrl
+#nsCaPolicyUrl
+#nsSslServerName
+
+# This really needs to be in place for it to be a proxy certificate.
+proxyCertInfo=critical,language:id-ppl-anyLanguage,pathlen:3,policy:foo
+
+####################################################################
+[ tsa ]
+
+default_tsa = tsa_config1	# the default TSA section
+
+[ tsa_config1 ]
+
+# These are used by the TSA reply generation only.
+dir		= ./demoCA		# TSA root directory
+serial		= $dir/tsaserial	# The current serial number (mandatory)
+crypto_device	= builtin		# OpenSSL engine to use for signing
+signer_cert	= $dir/tsacert.pem 	# The TSA signing certificate
+					# (optional)
+certs		= $dir/cacert.pem	# Certificate chain to include in reply
+					# (optional)
+signer_key	= $dir/private/tsakey.pem # The TSA private key (optional)
+
+default_policy	= tsa_policy1		# Policy if request did not specify it
+					# (optional)
+other_policies	= tsa_policy2, tsa_policy3	# acceptable policies (optional)
+digests		= md5, sha1		# Acceptable message digests (mandatory)
+accuracy	= secs:1, millisecs:500, microsecs:100	# (optional)
+clock_precision_digits  = 0	# number of digits after dot. (optional)
+ordering		= yes	# Is ordering defined for timestamps?
+				# (optional, default: no)
+tsa_name		= yes	# Must the TSA name be included in the reply?
+				# (optional, default: no)
+ess_cert_id_chain	= no	# Must the ESS cert id chain be included?
+				# (optional, default: no)
diff -Naur openssl-1.0.0q.orig/selftest/TestCA/reqs/req1.pem openssl-1.0.0q/selftest/TestCA/reqs/req1.pem
--- openssl-1.0.0q.orig/selftest/TestCA/reqs/req1.pem	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/selftest/TestCA/reqs/req1.pem	2017-04-25 16:23:41.381030826 +0200
@@ -0,0 +1,61 @@
+Certificate Request:
+    Data:
+        Version: 0 (0x0)
+        Subject: CN=Libopeay test cert 1, O=Opera, ST=Oslo, C=NO
+        Subject Public Key Info:
+            Public Key Algorithm: rsaEncryption
+                Public-Key: (2048 bit)
+                Modulus:
+                    00:bf:01:ea:4f:45:41:1e:96:83:5d:42:4a:a2:2b:
+                    70:16:f8:db:79:ec:66:07:45:4a:8a:85:d0:2b:c1:
+                    f0:6e:87:d9:e1:ad:1f:ea:9c:8b:0d:5c:3f:6f:9c:
+                    cb:8c:b3:88:1a:c1:10:0d:5f:53:0d:92:fc:72:30:
+                    2b:46:3e:05:8f:d1:7a:d9:5e:f6:d4:a8:3a:20:ca:
+                    c8:2c:ec:b4:8d:c5:91:0e:b3:b4:99:ad:0e:5c:43:
+                    75:c2:00:8d:b8:e9:11:54:71:60:e4:71:19:56:6d:
+                    cb:73:ca:a4:3d:3c:ef:de:08:0e:90:1b:2f:a4:8a:
+                    81:81:fd:ca:50:17:a0:a6:5c:a8:83:6c:36:54:a9:
+                    0f:f3:f1:ba:b1:fd:aa:92:07:2e:66:4e:51:4a:bb:
+                    fe:5c:cf:92:0d:ef:28:e0:95:12:fe:af:5f:fc:9a:
+                    3d:24:43:52:0f:41:15:99:9e:84:fc:fd:77:6f:2b:
+                    97:54:7e:cd:ba:e7:21:0f:52:2e:89:5b:83:9d:0d:
+                    36:2b:c2:62:32:ae:de:02:f2:ff:9e:d5:35:ad:b8:
+                    77:8d:06:cf:1e:ee:cd:c0:54:7a:3d:aa:ed:82:d1:
+                    64:df:7d:87:df:8f:cf:9d:cc:fd:d7:58:b6:af:87:
+                    03:19:0b:c5:21:f1:c8:83:72:bc:a3:fd:83:b8:ab:
+                    a5:d7
+                Exponent: 65537 (0x10001)
+        Attributes:
+            a0:00
+    Signature Algorithm: sha1WithRSAEncryption
+        a6:85:15:08:62:c8:c5:90:86:d9:95:40:5e:91:c5:13:15:b6:
+        2a:27:b2:07:17:d3:a9:56:57:b8:9f:19:f4:3b:8b:7b:66:c5:
+        a2:99:b6:27:54:cf:f6:89:67:a6:e0:e9:b5:d2:94:b3:47:ae:
+        e2:35:39:22:f2:d2:e0:1f:98:02:e0:79:5c:4a:3a:9d:94:c6:
+        b0:32:5a:36:05:44:c5:f5:22:f8:1f:af:ba:70:be:58:80:78:
+        a0:52:b5:de:f0:cd:38:13:d5:6a:e9:84:9f:5e:36:95:3a:33:
+        1d:b1:06:e9:6d:cc:2d:a2:a8:ff:ba:c5:a2:ca:81:83:a2:e2:
+        cd:ff:22:04:bb:5b:4f:78:0f:a4:c3:3b:6e:cc:6a:fd:bf:a1:
+        66:fc:e5:55:e3:df:e6:63:8e:8a:bb:fe:b3:64:43:7e:d2:80:
+        ab:a1:09:4f:ae:50:ea:61:ca:8b:15:e6:c9:5f:b6:28:ee:d9:
+        4a:6d:fb:2b:1d:65:1e:84:26:02:7e:5d:ec:32:b6:b7:cd:82:
+        97:76:cc:d5:4d:ad:c7:81:79:a3:e6:6a:da:ea:95:89:2c:b1:
+        f1:6a:0b:c3:27:b3:5a:90:60:ed:03:bc:75:cf:95:21:81:2a:
+        1d:1b:5e:d1:14:8d:a6:01:90:fc:74:fc:87:2e:fe:d0:ef:ba:
+        81:34:cd:8f
+-----BEGIN CERTIFICATE REQUEST-----
+MIICkDCCAXgCAQAwSzEdMBsGA1UEAwwUTGlib3BlYXkgdGVzdCBjZXJ0IDExDjAM
+BgNVBAoMBU9wZXJhMQ0wCwYDVQQIDARPc2xvMQswCQYDVQQGEwJOTzCCASIwDQYJ
+KoZIhvcNAQEBBQADggEPADCCAQoCggEBAL8B6k9FQR6Wg11CSqIrcBb423nsZgdF
+SoqF0CvB8G6H2eGtH+qciw1cP2+cy4yziBrBEA1fUw2S/HIwK0Y+BY/Retle9tSo
+OiDKyCzstI3FkQ6ztJmtDlxDdcIAjbjpEVRxYORxGVZty3PKpD08794IDpAbL6SK
+gYH9ylAXoKZcqINsNlSpD/PxurH9qpIHLmZOUUq7/lzPkg3vKOCVEv6vX/yaPSRD
+Ug9BFZmehPz9d28rl1R+zbrnIQ9SLolbg50NNivCYjKu3gLy/57VNa24d40Gzx7u
+zcBUej2q7YLRZN99h9+Pz53M/ddYtq+HAxkLxSHxyINyvKP9g7irpdcCAwEAAaAA
+MA0GCSqGSIb3DQEBBQUAA4IBAQCmhRUIYsjFkIbZlUBekcUTFbYqJ7IHF9OpVle4
+nxn0O4t7ZsWimbYnVM/2iWem4Om10pSzR67iNTki8tLgH5gC4HlcSjqdlMawMlo2
+BUTF9SL4H6+6cL5YgHigUrXe8M04E9Vq6YSfXjaVOjMdsQbpbcwtoqj/usWiyoGD
+ouLN/yIEu1tPeA+kwztuzGr9v6Fm/OVV49/mY46Ku/6zZEN+0oCroQlPrlDqYcqL
+FebJX7Yo7tlKbfsrHWUehCYCfl3sMra3zYKXdszVTa3HgXmj5mra6pWJLLHxagvD
+J7NakGDtA7x1z5UhgSodG17RFI2mAZD8dPyHLv7Q77qBNM2P
+-----END CERTIFICATE REQUEST-----
diff -Naur openssl-1.0.0q.orig/selftest/TestCA/reqs/req2.pem openssl-1.0.0q/selftest/TestCA/reqs/req2.pem
--- openssl-1.0.0q.orig/selftest/TestCA/reqs/req2.pem	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/selftest/TestCA/reqs/req2.pem	2017-04-25 16:23:41.382030953 +0200
@@ -0,0 +1,61 @@
+Certificate Request:
+    Data:
+        Version: 0 (0x0)
+        Subject: CN=Libopeay test cert 2, O=Opera, ST=Oslo, C=NO
+        Subject Public Key Info:
+            Public Key Algorithm: rsaEncryption
+                Public-Key: (2048 bit)
+                Modulus:
+                    00:c6:fd:2b:d8:5c:d6:a2:e5:7a:0e:91:ba:71:18:
+                    a0:79:f9:d2:ad:25:ea:95:16:62:dc:97:f4:13:2f:
+                    80:0a:71:9b:69:6e:86:3c:11:4d:6a:ed:5b:0d:74:
+                    a7:e0:22:36:e0:f7:1c:aa:8c:e6:d2:dd:85:84:7f:
+                    98:17:bf:0c:0a:6c:69:80:f9:72:61:fa:56:60:7c:
+                    3c:42:98:29:1a:87:7d:9e:11:32:1d:f8:60:57:c9:
+                    73:4c:2a:69:bb:9e:0f:f6:a4:b0:c9:40:bf:4d:f3:
+                    e1:cf:f9:2d:79:ed:4a:64:75:a8:f7:82:a9:7b:86:
+                    fa:2c:eb:49:f8:1d:a7:1c:eb:69:6c:cd:ed:e0:1e:
+                    69:7c:1b:fc:dc:42:2f:68:46:9b:ab:66:45:83:35:
+                    f2:c3:8d:d6:cf:b0:66:a5:81:02:05:c5:db:c7:c7:
+                    33:b2:80:af:9d:8e:b5:d1:71:97:46:f8:2c:55:23:
+                    e2:33:80:a0:0e:37:c6:a5:26:1e:28:44:a7:53:5a:
+                    c7:91:67:30:40:d8:9a:98:75:c1:1d:4b:c5:ed:16:
+                    9a:40:c2:a1:03:33:99:05:d4:c2:3c:41:8f:79:75:
+                    ae:79:ab:eb:d2:ef:8e:0f:ef:93:6b:a5:18:c3:13:
+                    ba:e4:c3:e9:84:cc:31:5c:ae:08:1e:bc:de:4a:20:
+                    3d:49
+                Exponent: 65537 (0x10001)
+        Attributes:
+            a0:00
+    Signature Algorithm: sha1WithRSAEncryption
+        21:d8:e4:5c:70:af:0f:aa:cb:79:4c:1c:67:42:ca:9e:a7:f1:
+        7d:fe:b5:0e:70:56:04:de:2c:44:6b:d7:cc:be:27:92:60:7f:
+        af:fb:43:aa:bd:81:8f:ab:a1:92:fb:5b:57:e6:d8:54:6f:2d:
+        72:0e:08:77:55:13:71:8b:44:cb:37:a7:3d:55:cc:74:74:f5:
+        9f:f8:75:a6:39:5d:47:4f:3c:a2:70:db:43:5c:81:e3:49:35:
+        e3:8f:b2:67:c3:44:bf:f6:80:ac:d7:90:68:b9:41:bd:c3:9f:
+        f5:54:30:f8:32:b8:9a:8e:f2:3a:34:e5:3f:00:ec:2e:bb:95:
+        23:53:04:1e:4c:19:68:18:8c:2d:36:8f:66:66:fc:e7:d2:85:
+        d5:f6:cc:e8:cb:63:df:1d:0a:25:bb:78:a4:2a:f1:59:1e:55:
+        ef:64:0e:53:c7:97:69:9a:b6:74:0e:a5:12:c6:7a:b0:20:f0:
+        d7:2a:1a:0f:9f:18:a1:be:c8:43:55:29:a1:50:30:18:97:c7:
+        f4:ff:74:bd:7c:db:39:3e:21:3b:38:3f:9f:7e:0f:b3:7f:54:
+        d2:a9:1b:72:13:5b:f0:4b:eb:3e:99:4a:80:80:f6:4b:ec:24:
+        61:7b:ef:8b:a1:7b:92:2e:3f:cb:09:4b:02:0a:72:8b:26:bb:
+        b8:18:1e:5b
+-----BEGIN CERTIFICATE REQUEST-----
+MIICkDCCAXgCAQAwSzEdMBsGA1UEAwwUTGlib3BlYXkgdGVzdCBjZXJ0IDIxDjAM
+BgNVBAoMBU9wZXJhMQ0wCwYDVQQIDARPc2xvMQswCQYDVQQGEwJOTzCCASIwDQYJ
+KoZIhvcNAQEBBQADggEPADCCAQoCggEBAMb9K9hc1qLleg6RunEYoHn50q0l6pUW
+YtyX9BMvgApxm2luhjwRTWrtWw10p+AiNuD3HKqM5tLdhYR/mBe/DApsaYD5cmH6
+VmB8PEKYKRqHfZ4RMh34YFfJc0wqabueD/aksMlAv03z4c/5LXntSmR1qPeCqXuG
++izrSfgdpxzraWzN7eAeaXwb/NxCL2hGm6tmRYM18sON1s+wZqWBAgXF28fHM7KA
+r52OtdFxl0b4LFUj4jOAoA43xqUmHihEp1Nax5FnMEDYmph1wR1Lxe0WmkDCoQMz
+mQXUwjxBj3l1rnmr69Lvjg/vk2ulGMMTuuTD6YTMMVyuCB683kogPUkCAwEAAaAA
+MA0GCSqGSIb3DQEBBQUAA4IBAQAh2ORccK8Pqst5TBxnQsqep/F9/rUOcFYE3ixE
+a9fMvieSYH+v+0OqvYGPq6GS+1tX5thUby1yDgh3VRNxi0TLN6c9Vcx0dPWf+HWm
+OV1HTzyicNtDXIHjSTXjj7Jnw0S/9oCs15BouUG9w5/1VDD4MriajvI6NOU/AOwu
+u5UjUwQeTBloGIwtNo9mZvzn0oXV9szoy2PfHQolu3ikKvFZHlXvZA5Tx5dpmrZ0
+DqUSxnqwIPDXKhoPnxihvshDVSmhUDAYl8f0/3S9fNs5PiE7OD+ffg+zf1TSqRty
+E1vwS+s+mUqAgPZL7CRhe++LoXuSLj/LCUsCCnKLJru4GB5b
+-----END CERTIFICATE REQUEST-----
diff -Naur openssl-1.0.0q.orig/selftest/ciphers.h openssl-1.0.0q/selftest/ciphers.h
--- openssl-1.0.0q.orig/selftest/ciphers.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/selftest/ciphers.h	2017-04-25 16:23:41.382030953 +0200
@@ -0,0 +1,9 @@
+
+#ifndef _LIBOPEY_SELFTEST_CIPHERS_H_
+#define _LIBOPEY_SELFTEST_CIPHERS_H_
+
+#include "modules/util/cleanse.h"
+
+typedef const EVP_CIPHER* (*EVP_CIPHER_CB)();
+
+#endif /* _LIBOPEY_SELFTEST_CIPHERS_H_ */
